## kraft 1.0

=== CMakeLists.txt ===
project(kraft)

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(SET CMP0063 NEW)

find_package(ECM REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
set(CMAKE_AUTOMOC TRUE)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(ECMInstallIcons)
include(KDEFrameworkCompilerSettings)
include(KDECMakeSettings)
include(FeatureSummary)

# Uncomment to enable some tweaks for AppImage build
# add_definitions(-DBUILD_APPIMAGE=1)

kde_enable_exceptions()
remove_definitions(-DQT_NO_SIGNALS_SLOTS_KEYWORDS)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

find_package(Qt5 CONFIG REQUIRED
    Core
    Gui
    Sql
    Widgets
    Xml
    Svg
)

# XmlGui for the ConfigSkeleton
find_package(KF5 REQUIRED COMPONENTS
    I18n
    Config
    Contacts
)

# Grantlee templating engine
find_package(Grantlee5 REQUIRED)
set_package_properties(Grantlee5 PROPERTIES
    DESCRIPTION "Library for templating html and pdf output"
    URL "https://www.grantlee.org/"
    PURPOSE "Optionally used for templating"
    TYPE OPTIONAL
)

find_package(KF5Akonadi)
set_package_properties(KF5Akonadi PROPERTIES
    DESCRIPTION "Library for general Access to Akonadi"
    URL "https://www.kde.org/"
    PURPOSE "Optionally used for addressbook integration"
    TYPE OPTIONAL
)

find_package(KF5AkonadiContact)
set_package_properties(KF5AkonadiContact PROPERTIES
    DESCRIPTION "Library for Accessing Contacts stored in Akonadi"
    URL "https://www.kde.org/"
    PURPOSE "Optionally used for addressbook integration"
    TYPE OPTIONAL
)

if(KF5Akonadi_FOUND AND KF5AkonadiContact_FOUND)
   add_definitions(-DHAVE_AKONADI)
endif()

find_package(Ctemplate REQUIRED)

find_package(Asciidoctor)
# Sets the variable ASCIIDOCTOR_FOUND

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-suggest-override")
# disable the warning about null-pointer zero. FIXME.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-zero-as-null-pointer-constant")

set(QT_DEFINITIONS "${Qt5Core_DEFINITIONS} ${Qt5Gui_DEFINITIONS} ${Qt5Widgets_DEFINITIONS}")
add_definitions(${QT_DEFINITIONS} )

include_directories(${QT_INCLUDES} src)
include_directories( /usr/include/KF5/AkonadiCore )

if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
        ki18n_install(po)
endif()

add_subdirectory(src)
add_subdirectory(database)
add_subdirectory(reports)
add_subdirectory(views)
add_subdirectory(importfilter)
add_subdirectory(tools)
add_subdirectory(styles)
add_subdirectory(meta)
add_subdirectory(tests)
add_subdirectory(manual)


feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR} ${KDEPIMLIBS_INCLUDE_DIRS} external)

include_directories(${QT_INCLUDES} src)
add_subdirectory(pics)

########### next target ###############
qt5_add_resources(KRAFT_RC_SRC pics/kraft.qrc)

set(kraft_SRCS
    attribute.cpp
    einheit.cpp
    doctype.cpp
    numbercycle.cpp
    katalogman.cpp
    stdsatzman.cpp
    katalog.cpp
    templkatalog.cpp
    docposition.cpp
    matkatalog.cpp
    calcdialogbase.cpp
    timecalcpart.cpp
    fixcalcpart.cpp
    floskeltemplate.cpp
    floskel.cpp
    calcpart.cpp
    kraftview.cpp
    kraftdoc.cpp
    catalogchapter.cpp
    addeditchapterdialog.cpp
    unitmanager.cpp
    stockmaterial.cpp
    materialcalcpart.cpp
    flostempldialog.cpp
    stdsatzman.cpp
    materialtempldialog.cpp
    timecalcdialog.cpp
    fixcalcdialog.cpp
    matcalcdialog.h
    matcalcdialog.cpp
    templatesaverbase.cpp
    templatesaverdb.cpp
    materialsaverbase.cpp
    materialsaverdb.cpp
    prefsdialog.cpp
    prefswages.cpp
    prefsunits.cpp
    katalogview.cpp
    filterheader.cpp
    kataloglistview.cpp
    templkatalogview.cpp
    templkataloglistview.cpp
    positionviewwidget.cpp
    documentsaverbase.cpp
    documentsaverdb.cpp
    exportxrechnung.cpp
    documentman.cpp
    docdigest.cpp
    alldocsview.cpp
    doctypeedit.cpp
    doctext.cpp
    portal.cpp
    portalview.cpp
    archiveman.cpp
    reportgenerator.cpp
    htmlview.cpp
    docpostcard.cpp
    catalogtemplate.cpp
    catalogselection.cpp
    kraftdocheaderedit.cpp
    kraftdocfooteredit.cpp
    inserttempldialog.cpp
    archdocposition.cpp
    archdoc.cpp
    materialkataloglistview.cpp
    materialkatalogview.cpp
    materialselectdialog.cpp
    kraftdocedit.cpp
    kraftdocpositionsedit.cpp
    portalhtmlview.cpp
    templtopositiondialogbase.cpp
    textselection.cpp
    newdocassistant.cpp
    docassistant.cpp
    texteditdialog.cpp
    templateprovider.cpp
    headertemplateprovider.cpp
    footertemplateprovider.cpp
    catalogtemplateprovider.cpp
    texttemplate.cpp
    grantleetemplate.cpp
    tagman.cpp
    itemtagdialog.cpp
    tagtemplatesdialog.cpp
    importitemdialog.cpp
    importfilter.cpp
    kraftview_ro.cpp
    taxeditdialog.cpp
    numbercycledialog.cpp
    impviewwidgets.cpp
    setupassistant.cpp
    models/documentmodel.cpp
    models/documentproxymodels.cpp
    models/datemodel.cpp
    models/docbasemodel.cpp
    docdigestdetailview.cpp
    addressprovider.cpp
    addressselectorwidget.cpp
    addressprovider_akonadi.cpp
    addressselectordialog.cpp
    kraftdb.cpp
    geld.cpp
    defaultprovider.cpp
    metaxmlparser.cpp
    texttemplateinterface.cpp
    documenttemplate.cpp
    pdfconverter.cpp
    format.cpp
    epcqrcode.cpp

    3rdparty/qrcodegen.cpp
)

kconfig_add_kcfg_files(kraft_SRCS
    databasesettings.kcfgc
    kraftsettings.kcfgc
)

ki18n_wrap_ui(kraft_SRCS
    calctemplate.ui
    dbinit.ui
    createdb.ui
    dbselect.ui
    mysqldetails.ui
    sqlitedetails.ui
    identity.ui
    statuspage.ui
    upgradedb.ui
    timepart.ui
    fixpartui.ui
    matpartui.ui
    inserttmplbase.ui
    materialdialog.ui
    docheader.ui
    positionwidget.ui
    docfooter.ui
    texteditbase.ui
    positionwidget.ui
    doctypeeditbase.ui
    taxeditbase.ui
    wageseditbase.ui
    unitseditbase.ui
    importtodocbase.ui
    numbercycleseditbase.ui
    xrechnung.ui
)

set(KRAFT_LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Sql
    Qt5::Xml

    KF5::I18n
    KF5::Contacts
    KF5::ConfigCore
    KF5::ConfigGui
    ${CTEMPLATE_LIBRARIES} pthread
    Grantlee5::Templates
)
if(KF5Akonadi_FOUND)
  list(APPEND KRAFT_LINK_LIBS
    KF5::AkonadiCore
    KF5::AkonadiContact
    KF5::AkonadiAgentBase
    KF5::AkonadiWidgets
    KF5::AkonadiXml
  )
endif()

add_library(kraftlib STATIC ${KRAFT_RC_SRC} ${kraft_SRCS})
target_compile_options(kraftlib PRIVATE -Wall -Wno-suggest-override)

add_executable(kraft main.cpp)

set_target_properties(kraft PROPERTIES OUTPUT_NAME kraft)

target_link_libraries(kraftlib
PUBLIC
    ${KRAFT_LINK_LIBS}
)

target_link_libraries(kraft
  PUBLIC
    kraftlib
)

install(TARGETS kraft ${INSTALL_TARGETS_DEFAULT_ARGS})

########### install files ###############

install(FILES  kraftsettings.kcfg databasesettings.kcfg DESTINATION ${KCFG_INSTALL_DIR})
install(FILES  kraftui.rc katalogview.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kraft)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(kraft)

cmake_policy(SET CMP0063 NEW)

enable_testing()

# Tell CMake to run moc when necessary:
# set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
# set(CMAKE_INCLUDE_CURRENT_DIR ON)

# include_directories( "${CMAKE_CURRENT_BINARY_DIR}/../src" )

find_package(Qt5Test REQUIRED)

set(test_libs Qt5::Test kraftlib)

add_executable(t_unitman t_unitman.cpp)
target_link_libraries(t_unitman ${test_libs})
add_test(t_unitman t_unitman)

# ============================================================ 

add_executable(t_format t_format.cpp)
add_test(t_format t_format)
target_link_libraries(t_format ${test_libs})

# ============================================================ 

add_executable(t_metaparser t_metaparser.cpp)
add_test(t_metaparser t_metaparser)

target_link_libraries(t_metaparser ${test_libs})

# ============================================================ 

add_executable(t_defaultprovider t_defaultprovider.cpp)
add_test(t_defaultprovider t_defaultprovider)

target_link_libraries(t_defaultprovider ${test_libs})

# ============================================================ 

add_executable(t_doctype t_doctype.cpp)
add_test(t_doctype t_doctype)

target_link_libraries(t_doctype ${test_libs})

# ============================================================

add_executable(t_attributes t_attributes.cpp)
add_test(t_attributes t_attributes)

target_link_libraries(t_attributes ${test_libs})

# ============================================================

set(TESTS_PATH ${CMAKE_CURRENT_SOURCE_DIR})
configure_file ("testconfig.h.in" "testconfig.h")

=== views/CMakeLists.txt ===
########### install files ###############

install(FILES
	docdigest.thtml
	identity.thtml
	kraftdoc_ro.thtml
	monthdigest.thtml
	systemviewdetails.thtml
	systemviewerror.thtml
	yeardigest.thtml
	DESTINATION ${DATA_INSTALL_DIR}/kraft/views)

=== debian/changelog ===
kraft (1.0-1ubuntu3) mantic; urgency=medium

  * Build without akonadi.

 -- Rik Mills <rikmills@kde.org>  Wed, 16 Aug 2023 10:41:43 +0100

kraft (1.0-1ubuntu2) mantic; urgency=medium

  * No-change rebuild against New KDE PIM..

 -- Rik Mills <rikmills@kde.org>  Wed, 16 Aug 2023 08:14:10 +0100

kraft (1.0-1ubuntu1) mantic; urgency=medium

  * Add fixakonadi.patch to fix build with latest akonadi.
    Thanks to Klaas Freitag @ opensuse.

 -- Rik Mills <rikmills@kde.org>  Thu, 15 Jun 2023 13:24:49 +0100

kraft (1.0-1build1) mantic; urgency=medium

  * No-change rebuild against new KDE PIM..

 -- Rik Mills <rikmills@kde.org>  Thu, 15 Jun 2023 12:58:56 +0100

kraft (1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2, no changes required.
  * Update the build dependencies according to the upstream build system:
    - add libqt5svg5-dev
  * Remove inactive Uploaders, adding myself as one to avoid leaving the source
    with no human maintainers.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Fri, 23 Dec 2022 14:47:38 +0100

=== debian/control ===
Source: kraft
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               pkg-kde-tools (>= 0.15.16),
               cmake,
               dh-python,
               extra-cmake-modules,
               gettext,
               qtbase5-dev,
               libqt5svg5-dev,
#               libkf5akonadi-dev,
#               libkf5akonadicontact-dev,
               libkf5config-dev,
               libkf5contacts-dev,
               libkf5i18n-dev,
               libctemplate-dev,
               libgrantlee5-dev,
               python3:any,
               asciidoctor,
               po4a,
               libqt5sql5-sqlite <!nocheck>,
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://volle-kraft-voraus.de/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kraft.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kraft

Package: kraft
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqt5sql5-sqlite,
         ${python3:Depends},
         python3-reportlab,
         python3-six,
         python3-pypdf2,
Recommends: libqt5sql5-mysql,
            weasyprint,
Description: small business-management application
 Kraft creates and handles office documents in small enterprises. In a workshop
 or any similar company daily tasks can be done in a smart manner.
 .
 Features include:
  Customer management, integrated using KAddressbook
  Automated creation of quotes, invoices and similar documents
  Text templates
  Calculation
  Material management
  Configurable document creation in PDF format

## kraft 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,58 @@
 project(kraft)
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.16.0)
 cmake_policy(SET CMP0063 NEW)
 
 find_package(ECM REQUIRED NO_MODULE)
 
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set(CMAKE_AUTOMOC TRUE)
+
+option(AKONADI_LEGACY_BUILD "Build with older versions of Akonadi (KF5 Prefix)" OFF)
+# Akonadi Prefix: Set this to KF5 for builds with Akonadi Libs before 5.23
+set(AKO_PREFIX "KPim5")
+
+if (AKONADI_LEGACY_BUILD)
+  set(AKO_PREFIX "KF5")
+endif()
+message("Akonadi Prefix is ${AKO_PREFIX}")
+
+include(GetGitRevisionDescription)
+
+# set git revision info
+get_git_head_revision(GIT_REFSPEC GIT_SHA1)
+# if we cannot get it from git, directly try .tag (packages)
+# this will work if the tar balls have been properly created
+# via git-archive.
+if ("${GIT_SHA1}" STREQUAL "GITDIR-NOTFOUND")
+    file(READ ${CMAKE_SOURCE_DIR}/.tag sha1_candidate)
+    string(REPLACE "\n" "" sha1_candidate ${sha1_candidate})
+    if (NOT ${sha1_candidate} STREQUAL "$Format:%H$")
+        message("${sha1_candidate}")
+        set (GIT_SHA1 "${sha1_candidate}")
+    endif()
+endif()
+
+message(STATUS "Git dynamic information")
+message("GIT_SHA1: ${GIT_SHA1}")
+
+execute_process(
+  COMMAND git rev-parse --abbrev-ref HEAD
+  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+  OUTPUT_VARIABLE GIT_BRANCH
+  OUTPUT_STRIP_TRAILING_WHITESPACE
+)
+message("GIT_BRANCH: ${GIT_BRANCH}")
+
+cmake_host_system_information(RESULT BUILD_HOST_NAME QUERY HOSTNAME)
+if(${CMAKE_VERSION} VERSION_GREATER "3.22.0")
+    cmake_host_system_information(RESULT BUILD_HOST_DISTRI QUERY DISTRIB_PRETTY_NAME)
+else ()
+    set(BUILD_HOST_DISTRI "unknown distribution")
+endif()
+message("Build host name: ${BUILD_HOST_NAME}")
+message("Build host distribution: ${BUILD_HOST_DISTRI}")
+
 
 include(KDEInstallDirs)
 include(KDECMakeSettings)
@@ -47,23 +93,31 @@
     TYPE OPTIONAL
 )
 
-find_package(KF5Akonadi)
-set_package_properties(KF5Akonadi PROPERTIES
+find_package(${AKO_PREFIX}Akonadi)
+set_package_properties(${AKO_PREFIX}Akonadi PROPERTIES
     DESCRIPTION "Library for general Access to Akonadi"
     URL "https://www.kde.org/"
     PURPOSE "Optionally used for addressbook integration"
     TYPE OPTIONAL
 )
 
-find_package(KF5AkonadiContact)
-set_package_properties(KF5AkonadiContact PROPERTIES
+find_package(${AKO_PREFIX}AkonadiContact)
+set_package_properties(${AKO_PREFIX}AkonadiContact PROPERTIES
     DESCRIPTION "Library for Accessing Contacts stored in Akonadi"
     URL "https://www.kde.org/"
     PURPOSE "Optionally used for addressbook integration"
     TYPE OPTIONAL
 )
 
-if(KF5Akonadi_FOUND AND KF5AkonadiContact_FOUND)
+find_package(${AKO_PREFIX}ContactEditor)
+set_package_properties(${AKO_PREFIX}ContactEditor PROPERTIES
+    DESCRIPTION "Library for editing contacts stored in Akonadi"
+    URL "https://www.kde.org/"
+    PURPOSE "Optionally used for addressbook integration"
+    TYPE OPTIONAL
+)
+
+if(${AKO_PREFIX}Akonadi_FOUND AND ${AKO_PREFIX}AkonadiContact_FOUND AND ${AKO_PREFIX}ContactEditor_FOUND)
    add_definitions(-DHAVE_AKONADI)
 endif()
 
@@ -80,7 +134,8 @@
 add_definitions(${QT_DEFINITIONS} )
 
 include_directories(${QT_INCLUDES} src)
-include_directories( /usr/include/KF5/AkonadiCore )
+include_directories( /usr/include/${AKO_PREFIX}/AkonadiCore )
+include_directories(/usr/include/${AKO_PREFIX}/)
 
 if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
         ki18n_install(po)

=== manual/CMakeLists.txt ===

FIND_PACKAGE(Asciidoctor)
SET (install_files kraft-en.html kraft-de.html)

if (ASCIIDOCTOR_FOUND)
  SET( manual_src ${PROJECT_SOURCE_DIR}/manual/kraft.adoc )
  SET( out_file kraft-en.html )

  ADD_CUSTOM_COMMAND(
    OUTPUT "${out_file}"
    COMMAND "${PROJECT_SOURCE_DIR}/manual/makeman.sh" ARGS "${PROJECT_SOURCE_DIR}/manual"
    DEPENDS ${manual_src}
    COMMENT "Make the manual"
  )
  message( "Asciidoctor found")
  ADD_CUSTOM_TARGET(manual ALL echo
    DEPENDS "${out_file}"
  )

  INSTALL(FILES ${CMAKE_BINARY_DIR}/manual/kraft-en.html ${CMAKE_BINARY_DIR}/manual/kraft-de.html ${CMAKE_BINARY_DIR}/manual/kraft-nl.html
          DESTINATION ${DATA_INSTALL_DIR}/kraft/manual)

else(ASCIIDOCTOR_FOUND)
  # Maybe there are preinstalled html files in the tarball
  message("Asciidoctor not found, installing pre built manual.")
  install(FILES "kraft-de.html" "kraft-en.html" DESTINATION ${DATA_INSTALL_DIR}/kraft/manual)
endif(ASCIIDOCTOR_FOUND)

INSTALL(FILES kraftmanual.css DESTINATION ${DATA_INSTALL_DIR}/kraft/manual)
INSTALL(DIRECTORY images DESTINATION ${DATA_INSTALL_DIR}/kraft/manual)

=== meta/CMakeLists.txt ===
########### install files ###############

install(FILES  kraft.desktop DESTINATION ${XDG_APPS_INSTALL_DIR} RENAME de.volle_kraft_voraus.kraft.desktop)
install(FILES  kraft.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} RENAME de.volle_kraft_voraus.kraft.appdata.xml)

=== database/sqlite3/migration/CMakeLists.txt ===
########### install files ###############

file(GLOB mig_scripts *_dbmigrate.sql)
install(FILES ${mig_scripts} 
	DESTINATION ${DATA_INSTALL_DIR}/kraft/dbmigrate/sqlite3)

=== debian/changelog ===
kraft (1.1-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:38:18 +1100

kraft (1.1-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:16:35 +0000

kraft (1.1-1ubuntu2) noble; urgency=medium

  * Rebuild against latest ctemplate

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 06 Mar 2024 19:42:28 -0500

kraft (1.1-1ubuntu1) noble; urgency=medium

  * Pass -DAKONADI_LEGACY_BUILD=OFF to cmake as Ubuntu has the latest
    akonadi release 23.08.2.

 -- Rik Mills <rikmills@kde.org>  Fri, 27 Oct 2023 12:43:33 +0100

kraft (1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16.0
  * Pass -DAKONADI_LEGACY_BUILD=ON to cmake to build with Akonadi older than
    23.04 (i.e. what currently available in Debian unstable).
  * Fix source build without git or a .git directory around:
    - do not try to get git branch information if there is no .git directory;
      patch cmake-fix-without-git.diff
    - create a ".tag" file for the cmake run, since apparently the build system
      assumes it is there (while it is not) in case .git is not present
  * Make the tests pass:
    - add the locales-all build dependency
    - run tests using the de_DE.utf8 locale
    - fix the expected date strings when no date format is configured; patch
      tests-dateformat.diff

 -- Pino Toscano <pino@debian.org>  Sun, 17 Sep 2023 06:01:17 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                pkg-kde-tools (>= 0.15.16),
-               cmake,
+               cmake (>= 3.16.0~),
                dh-python,
                extra-cmake-modules,
                gettext,
                qtbase5-dev,
                libqt5svg5-dev,
-#               libkf5akonadi-dev,
-#               libkf5akonadicontact-dev,
+               libkf5akonadi-dev,
+               libkf5akonadicontact-dev,
                libkf5config-dev,
                libkf5contacts-dev,
                libkf5i18n-dev,
@@ -23,6 +23,7 @@
                asciidoctor,
                po4a,
                libqt5sql5-sqlite <!nocheck>,
+               locales-all <!nocheck>,
                xauth <!nocheck>,
                xvfb <!nocheck>,
 Standards-Version: 4.6.2

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with kf5,python3

override_dh_auto_configure:
	# workaround lack of ".tag: top-level file assumed by the build system
	# in case no .git directory is present
	echo 'unavailable' > .tag
	dh_auto_configure -Skf5 -- -DAKONADI_LEGACY_BUILD=OFF
	rm .tag

override_dh_auto_test:
	xvfb-run -a env KRAFT_HOME="$(CURDIR)" LC_ALL=de_DE.utf8 dh_auto_test --no-parallel

## kraft 1.2.1

=== debian/changelog ===
kraft (1.2.1-1ubuntu1) oracular; urgency=medium

  * Pass -DAKONADI_LEGACY_BUILD=OFF to cmake as Ubuntu has akonadi
    release 23.08.5.

 -- Rik Mills <rikmills@kde.org>  Mon, 06 May 2024 19:47:53 +0100

kraft (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - cmake-fix-without-git.diff: refresh
  * Include /usr/share/dpkg/pkg-info.mk: this makes SOURCE_DATE_EPOCH exported
    during the build, and the upstream build system will not embed the hostname
    of the build host.
  * Drop the ".tag" file created for running cmake, as the upstream build system
    now gracefully handles its lack.
  * The tests now properly pass no matter which locale is set for the build
    host, so:
    - drop the tests-dateformat.diff patch
    - stop setting the de_DE.utf8 locale when running the tests
  * Drop the python3-six dependency, as the six Python module is no more used
    now. (Closes: #1067723)
  * Bump Standards-Version to 4.7.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Mon, 06 May 2024 13:53:00 +0200

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
                locales-all <!nocheck>,
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://volle-kraft-voraus.de/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kraft.git
@@ -39,7 +39,6 @@
          libqt5sql5-sqlite,
          ${python3:Depends},
          python3-reportlab,
-         python3-six,
          python3-pypdf2,
 Recommends: libqt5sql5-mysql,
             weasyprint,

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# make SOURCE_DATE_EPOCH available during the build, so the build host
# is not embedded into the binary
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with kf5,python3

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DAKONADI_LEGACY_BUILD=OFF

override_dh_auto_test:
	xvfb-run -a env KRAFT_HOME="$(CURDIR)" dh_auto_test --no-parallel

## kraft 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
+cmake_minimum_required(VERSION 3.16.0)
 project(kraft)
-
-cmake_minimum_required(VERSION 3.16.0)
 cmake_policy(SET CMP0063 NEW)
 
 find_package(ECM REQUIRED NO_MODULE)
@@ -25,11 +24,15 @@
 # this will work if the tar balls have been properly created
 # via git-archive.
 if ("${GIT_SHA1}" STREQUAL "GITDIR-NOTFOUND")
-    file(READ ${CMAKE_SOURCE_DIR}/.tag sha1_candidate)
-    string(REPLACE "\n" "" sha1_candidate ${sha1_candidate})
-    if (NOT ${sha1_candidate} STREQUAL "$Format:%H$")
-        message("${sha1_candidate}")
-        set (GIT_SHA1 "${sha1_candidate}")
+    if (EXISTS "${CMAKE_SOURCE_DIR}/.tag")
+        file(READ ${CMAKE_SOURCE_DIR}/.tag sha1_candidate)
+        string(REPLACE "\n" "" sha1_candidate ${sha1_candidate})
+        if (NOT ${sha1_candidate} STREQUAL "$Format:%H$")
+            message("${sha1_candidate}")
+            set (GIT_SHA1 "${sha1_candidate}")
+        endif()
+    else()
+        set (GIT_SHA1 "unknown")
     endif()
 endif()
 
@@ -44,7 +47,11 @@
 )
 message("GIT_BRANCH: ${GIT_BRANCH}")
 
-cmake_host_system_information(RESULT BUILD_HOST_NAME QUERY HOSTNAME)
+if($ENV{SOURCE_DATE_EPOCH})
+    set(BUILD_HOST_NAME "reproduciblebuild")
+else ()
+    cmake_host_system_information(RESULT BUILD_HOST_NAME QUERY HOSTNAME)
+endif()
 if(${CMAKE_VERSION} VERSION_GREATER "3.22.0")
     cmake_host_system_information(RESULT BUILD_HOST_DISTRI QUERY DISTRIB_PRETTY_NAME)
 else ()

=== database/CMakeLists.txt ===
add_subdirectory(mysql)
add_subdirectory(sqlite3)
add_subdirectory(meta)

=== importfilter/CMakeLists.txt ===
########### install files ###############

install(FILES woerlein_txt.ftr standard_txt.ftr DESTINATION ${DATA_INSTALL_DIR}/kraft/importfilter/positions/)

=== reports/CMakeLists.txt ===
add_subdirectory(pics)

########### install files ###############

install(FILES
        delivery_receipt.trml
        invoice.trml
	kraft.css
	invoice.gtmpl
	xrechnung.xrtmpl
	DESTINATION ${DATA_INSTALL_DIR}/kraft/reports)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
-# include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR} ${KDEPIMLIBS_INCLUDE_DIRS} external)
 
 include_directories(${QT_INCLUDES} src)
 add_subdirectory(pics)
+
+configure_file(${CMAKE_CURRENT_LIST_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h @ONLY)
 
 ########### next target ###############
 qt5_add_resources(KRAFT_RC_SRC pics/kraft.qrc)
@@ -115,6 +116,7 @@
     documenttemplate.cpp
     pdfconverter.cpp
     format.cpp
+    stringutil.cpp
     epcqrcode.cpp
 
     3rdparty/qrcodegen.cpp
@@ -167,13 +169,14 @@
     ${CTEMPLATE_LIBRARIES} pthread
     Grantlee5::Templates
 )
-if(KF5Akonadi_FOUND)
+if(${AKO_PREFIX}Akonadi_FOUND)
   list(APPEND KRAFT_LINK_LIBS
-    KF5::AkonadiCore
-    KF5::AkonadiContact
-    KF5::AkonadiAgentBase
-    KF5::AkonadiWidgets
-    KF5::AkonadiXml
+    ${AKO_PREFIX}::AkonadiCore
+    ${AKO_PREFIX}::AkonadiContact
+    ${AKO_PREFIX}::ContactEditor
+    ${AKO_PREFIX}::AkonadiAgentBase
+    ${AKO_PREFIX}::AkonadiWidgets
+    ${AKO_PREFIX}::AkonadiXml
   )
 endif()

=== styles/CMakeLists.txt ===
########### install files ###############
add_subdirectory(pics)

install(FILES templcatalog.style DESTINATION ${DATA_INSTALL_DIR}/kraft/styles)
install(FILES docdigestview.css docoverview.css docoverview_ro.css catalogview.css systemview.css DESTINATION ${DATA_INSTALL_DIR}/kraft/styles)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,21 @@
 
 # ============================================================
 
+add_executable(t_stringutil t_stringutil.cpp)
+add_test(t_stringutil t_stringutil)
+
+target_link_libraries(t_stringutil ${test_libs})
+
+# ============================================================
+
+add_executable(t_kraftdoc t_kraftdoc.cpp)
+add_test(t_kraftdoc t_kraftdoc)
+
+target_link_libraries(t_kraftdoc ${test_libs})
+
+# ============================================================
+
+
 set(TESTS_PATH ${CMAKE_CURRENT_SOURCE_DIR})
 configure_file ("testconfig.h.in" "testconfig.h")

=== tools/CMakeLists.txt ===

set(findcontact_NAME findcontact)
set(FINDCONTACT_SRC findcontact.cpp ../src/addressprovider.cpp ../src/addressprovider_akonadi.cpp)

set(AUTOMOC ON)

#
# For now there is only the Akonadi based address backend, and thus
# the findcontact tool is only built if akonadi is there.
# If there are other backends, this must be FIXED.
if(${AKO_PREFIX}Akonadi_FOUND)
    add_executable(${findcontact_NAME} ${FINDCONTACT_SRC})

    target_link_libraries( ${findcontact_NAME}
        Qt5::Core
        Qt5::Widgets
        KF5::Contacts
        ${AKO_PREFIX}::AkonadiCore
        ${AKO_PREFIX}::AkonadiContact
    )

    ########### install files ###############
    install(TARGETS ${findcontact_NAME} ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()

install(FILES erml2pdf.py watermarkpdf.py  DESTINATION ${DATA_INSTALL_DIR}/kraft/tools )

=== database/mysql/CMakeLists.txt ===
add_subdirectory(migration)

########### install files ###############

install(FILES create_schema.sql fill_schema_de.sql fill_schema_en.sql  DESTINATION ${DATA_INSTALL_DIR}/kraft/dbinit/mysql)

=== reports/pics/CMakeLists.txt ===
########### install files ###############

install(FILES lurchie.png DESTINATION ${DATA_INSTALL_DIR}/kraft/reports/images)
install(FILES postit.png kraft_customer.png DESTINATION ${DATA_INSTALL_DIR}/kraft/reports/images/docdigestdetailview)
install(FILES identity.png DESTINATION ${DATA_INSTALL_DIR}/kraft/reports/images)

=== src/pics/CMakeLists.txt ===

########### install files ###############

install(FILES kraftapp_logo.png DESTINATION ${DATA_INSTALL_DIR}/kraft/pics)

ecm_install_icons( ICONS sc-apps-kraft.svg DESTINATION ${KDE_INSTALL_ICONDIR})

=== debian/changelog ===
kraft (1.2.2-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Do not build with akonadi. Required Qt5 version is being replaced
      with Qt6 in Ubuntu.

 -- Rik Mills <rikmills@kde.org>  Tue, 05 Nov 2024 14:48:39 +0000

kraft (1.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Wed, 02 Oct 2024 06:52:55 +0200

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,6 @@
                gettext,
                qtbase5-dev,
                libqt5svg5-dev,
-               libkf5akonadi-dev,
-               libkf5akonadicontact-dev,
                libkf5config-dev,
                libkf5contacts-dev,
                libkf5i18n-dev,

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?([\d.]+)\.tar\.gz/kraft-$1\.tar\.gz/" \
  https://github.com/dragotin/kraft/tags .*/v?([\d.]+)\.tar\.gz

## kraft 2.0.0~rc1

=== debian/changelog ===
kraft (2.0.0~rc1-1) experimental; urgency=medium

  * New upstream development release:
    - switches to Qt5/KF5 (Closes: #1088983)
    - erml2pdf.py is no more shipped (Closes: #1083203)
    - watermarkpdf.py switches to pypdf (Related: #1029734)
  * Update watch file to handle also beta/rc versions, and skip tags without dot
    in them (hard to programmatically distinguish the version).
  * Update the patches:
    - tests-skip-t_defaultprovider.diff: refresh
    - cmake-fix-without-git.diff: refresh
  * Update the build dependencies following the port to Qt 6:
    - remove qtbase5-dev, libqt5svg5-dev, libkf5akonadi-dev,
      libkf5akonadicontact-dev, libkf5config-dev, libkf5contacts-dev,
      libkf5i18n-dev, libgrantlee5-dev, and libqt5sql5-sqlite
    - add qt6-base-dev, qt6-svg-dev, libkf6config-dev, libkf6contacts-dev,
      libkf6i18n-dev, libkf6texttemplate-dev, libakonadi-dev,
      libakonadicontact-dev, and libqt6sql6-sqlite
  * Update the other build dependencies according to the upstream build system:
    - bump extra-cmake-modules to 6.0.0
    - drop libctemplate-dev, no more needed now
  * Switch the kf5 dh addon to kf6.
  * Modernize building:
    - add the dh-sequence-kf6 build dependency to use the kf6 addon
      automatically
    - add the dh-sequence-python3 build dependency to use the python3 addon
      automatically
    - drop the pkg-kde-tools build dependency, no more explicitly needed
    - drop all the manually specified addons and buildsystem for dh
  * Switch the dependencies/recommends libqt5sql5-sqlite, and libqt5sql5-mysql
    to libqt6sql6-sqlite, and libqt6sql6-mysql.
  * Drop the -DAKONADI_LEGACY_BUILD=ON cmake argument, as it is no more legacy
    API to use.
  * Tweak the add_test() CMake calls to ensure the test executables are found;
    patch tests-new-add_test.diff
    - adapt tests-skip-t_defaultprovider.diff to it
  * Switch the python3-pypdf2 dependency to python3-pypdf, as watermarkpdf.py
    now is ported to the latter. (Closes: #1029734)
  * Drop the python3-reportlab dependency: it was needed for erml2pdf.py, which
    is no more shipped now.
  * The rebuild ensures that existing packages are used; python3-pypdf2 was
    handled on its own, and mentioned above. (Closes: #1115424)
  * Bump Standards-Version to 4.7.2, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Switch Vcs-* fields to the 'experimental' packaging branch.

 -- Pino Toscano <pino@debian.org>  Tue, 23 Dec 2025 00:59:46 +0100

=== debian/control ===
Source: kraft
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.16.0~),
               dh-sequence-kf6,
               dh-sequence-python3,
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               qt6-base-dev (>= 6.2.4~),
               qt6-svg-dev (>= 6.2.4~),
               libkf6config-dev,
               libkf6contacts-dev,
               libkf6i18n-dev,
               libkf6texttemplate-dev,
               libakonadi-dev,
               libakonadicontact-dev,
               python3:any,
               asciidoctor,
               po4a,
               libqt6sql6-sqlite <!nocheck>,
               locales-all <!nocheck>,
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://volle-kraft-voraus.de/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kraft.git -b experimental
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kraft/-/tree/experimental

Package: kraft
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqt6sql6-sqlite,
         ${python3:Depends},
         python3-pypdf,
Recommends: libqt6sql6-mysql,
            weasyprint,
Description: small business-management application
 Kraft creates and handles office documents in small enterprises. In a workshop
 or any similar company daily tasks can be done in a smart manner.
 .
 Features include:
  Customer management, integrated using KAddressbook
  Automated creation of quotes, invoices and similar documents
  Text templates
  Calculation
  Material management
  Configurable document creation in PDF format

=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,7 @@
 include /usr/share/dpkg/pkg-info.mk
 
 %:
-	dh $@ --with kf5,python3
-
-override_dh_auto_configure:
-	dh_auto_configure -Skf5 -- -DAKONADI_LEGACY_BUILD=OFF
+	dh $@
 
 override_dh_auto_test:
 	xvfb-run -a env KRAFT_HOME="$(CURDIR)" dh_auto_test --no-parallel

## kraft 2.0.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,10 @@
-
-include_directories(${QT_INCLUDES} src)
+# include_directories(${QT_INCLUDES} src)
 add_subdirectory(pics)
 
 configure_file(${CMAKE_CURRENT_LIST_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h @ONLY)
 
 ########### next target ###############
-qt5_add_resources(KRAFT_RC_SRC pics/kraft.qrc)
+qt6_add_resources(KRAFT_RC_SRC pics/kraft.qrc)
 
 set(kraft_SRCS
     attribute.cpp
@@ -54,6 +53,8 @@
     documentsaverbase.cpp
     documentsaverdb.cpp
     exportxrechnung.cpp
+    documentsaverxml.cpp
+    dbtoxmlconverter.cpp
     documentman.cpp
     docdigest.cpp
     alldocsview.cpp
@@ -61,7 +62,6 @@
     doctext.cpp
     portal.cpp
     portalview.cpp
-    archiveman.cpp
     reportgenerator.cpp
     htmlview.cpp
     docpostcard.cpp
@@ -70,8 +70,6 @@
     kraftdocheaderedit.cpp
     kraftdocfooteredit.cpp
     inserttempldialog.cpp
-    archdocposition.cpp
-    archdoc.cpp
     materialkataloglistview.cpp
     materialkatalogview.cpp
     materialselectdialog.cpp
@@ -87,7 +85,6 @@
     headertemplateprovider.cpp
     footertemplateprovider.cpp
     catalogtemplateprovider.cpp
-    texttemplate.cpp
     grantleetemplate.cpp
     tagman.cpp
     itemtagdialog.cpp
@@ -103,11 +100,14 @@
     models/documentproxymodels.cpp
     models/datemodel.cpp
     models/docbasemodel.cpp
+    models/contactsdirmodel.cpp
     docdigestdetailview.cpp
     addressprovider.cpp
     addressselectorwidget.cpp
-    addressprovider_akonadi.cpp
+    addressproviderakonadi.cpp
+    addressproviderlocal.cpp
     addressselectordialog.cpp
+    addressproviderprivate.cpp
     kraftdb.cpp
     geld.cpp
     defaultprovider.cpp
@@ -118,7 +118,14 @@
     format.cpp
     stringutil.cpp
     epcqrcode.cpp
-
+    kraftattrib.cpp
+    kraftobj.cpp
+    xmldocindex.cpp
+    jsonindexfile.cpp
+    reportitemlist.cpp
+    reportitem.cpp
+    docidentgenerator.cpp
+    myidentity.cpp
     3rdparty/qrcodegen.cpp
 )
 
@@ -127,7 +134,7 @@
     kraftsettings.kcfgc
 )
 
-ki18n_wrap_ui(kraft_SRCS
+set( kraft_UIS
     calctemplate.ui
     dbinit.ui
     createdb.ui
@@ -154,38 +161,49 @@
     importtodocbase.ui
     numbercycleseditbase.ui
     xrechnung.ui
-)
+    documentactions.ui
+    finalizedoc.ui
+    dbtoxml.ui
+)
+
+ki18n_wrap_ui(kraft_SRCS ${kraft_UIS})
 
 set(KRAFT_LINK_LIBS
-    Qt5::Core
-    Qt5::Widgets
-    Qt5::Sql
-    Qt5::Xml
-
-    KF5::I18n
-    KF5::Contacts
-    KF5::ConfigCore
-    KF5::ConfigGui
-    ${CTEMPLATE_LIBRARIES} pthread
-    Grantlee5::Templates
+    Qt6::Core
+    Qt6::Widgets
+    Qt6::Sql
+    Qt6::Xml
+
+    KF6::I18n
+    KF6::Contacts
+    KF6::ConfigCore
+    KF6::ConfigGui
+    pthread
+    KF6::TextTemplate
 )
 if(${AKO_PREFIX}Akonadi_FOUND)
   list(APPEND KRAFT_LINK_LIBS
     ${AKO_PREFIX}::AkonadiCore
-    ${AKO_PREFIX}::AkonadiContact
-    ${AKO_PREFIX}::ContactEditor
-    ${AKO_PREFIX}::AkonadiAgentBase
     ${AKO_PREFIX}::AkonadiWidgets
-    ${AKO_PREFIX}::AkonadiXml
+    ${AKO_PREFIX}::AkonadiContactCore
+    ${AKO_PREFIX}::AkonadiContactWidgets
   )
 endif()
 
-add_library(kraftlib STATIC ${KRAFT_RC_SRC} ${kraft_SRCS})
+qt_add_library(kraftlib STATIC ${KRAFT_RC_SRC} ${kraft_SRCS})
+
+# Use this with newer versions of Qt and remove the AUTOMOC in main CMakeLists.txt
+# qt_add_ui(kraftlib  SOURCES ${kraft_UIS})
+
 target_compile_options(kraftlib PRIVATE -Wall -Wno-suggest-override)
-
-add_executable(kraft main.cpp)
+target_include_directories(kraftlib PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/models ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty)
+
+qt_add_executable(kraft
+    MANUAL_FINALIZATION
+    main.cpp)
 
 set_target_properties(kraft PROPERTIES OUTPUT_NAME kraft)
+target_include_directories(kraft PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
 target_link_libraries(kraftlib
 PUBLIC
@@ -193,13 +211,12 @@
 )
 
 target_link_libraries(kraft
-  PUBLIC
+  PRIVATE
     kraftlib
 )
 
+qt_finalize_executable(kraft)
+
+
 install(TARGETS kraft ${INSTALL_TARGETS_DEFAULT_ARGS})
 
-########### install files ###############
-
-install(FILES  kraftsettings.kcfg databasesettings.kcfg DESTINATION ${KCFG_INSTALL_DIR})
-install(FILES  kraftui.rc katalogview.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kraft)

=== tests/CMakeLists.txt ===
enable_testing()

# Tell CMake to run moc when necessary:
# set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
# set(CMAKE_INCLUDE_CURRENT_DIR ON)

# include_directories( "${CMAKE_CURRENT_BINARY_DIR}/../src" )

set(test_libs Qt6::Test kraftlib)

add_executable(t_unitman t_unitman.cpp)
target_link_libraries(t_unitman ${test_libs})
add_test(NAME t_unitman COMMAND t_unitman)

# ============================================================

add_executable(t_format t_format.cpp)
add_test(NAME t_format COMMAND t_format)
target_link_libraries(t_format ${test_libs})

# ============================================================

add_executable(t_metaparser t_metaparser.cpp)
add_test(NAME t_metaparser COMMAND t_metaparser)

target_link_libraries(t_metaparser ${test_libs})

# ============================================================

add_executable(t_defaultprovider t_defaultprovider.cpp)
add_test(NAME t_defaultprovider COMMAND t_defaultprovider)

target_link_libraries(t_defaultprovider ${test_libs})

# ============================================================ 

add_executable(t_doctype t_doctype.cpp)
add_test(NAME t_doctype COMMAND t_doctype)

target_link_libraries(t_doctype ${test_libs})

# ============================================================

add_executable(t_numbercycle t_numbercycle.cpp)
add_test(NAME t_numbercycle COMMAND t_numbercycle)

target_link_libraries(t_numbercycle ${test_libs})

# ============================================================

add_executable(t_attributes t_attributes.cpp)
add_test(NAME t_attributes COMMAND t_attributes)

target_link_libraries(t_attributes ${test_libs})

# ============================================================

add_executable(t_stringutil t_stringutil.cpp)
add_test(NAME t_stringutil COMMAND t_stringutil)

target_link_libraries(t_stringutil ${test_libs})

# ============================================================

add_executable(t_kraftdoc t_kraftdoc.cpp)
add_test(NAME t_kraftdoc COMMAND t_kraftdoc)

target_link_libraries(t_kraftdoc ${test_libs})

# ============================================================

add_executable(t_docposition t_docposition.cpp)
add_test(NAME t_docposition COMMAND t_docposition)

target_link_libraries(t_docposition ${test_libs})

# ============================================================


set(TESTS_PATH ${CMAKE_CURRENT_SOURCE_DIR})
configure_file ("testconfig.h.in" "testconfig.h")

# ============================================================

add_executable(t_xmlsaver t_xmlsaver.cpp)
add_test(NAME t_xmlsaver COMMAND t_xmlsaver)

target_link_libraries(t_xmlsaver ${test_libs})

# ============================================================

add_executable(t_xmldocindex t_xmldocindex.cpp)
add_test(NAME t_xmldocindex COMMAND t_xmldocindex)

target_link_libraries(t_xmldocindex ${test_libs})

# ============================================================

add_executable(t_kraftattrib t_kraftattrib.cpp)
add_test(NAME t_kraftattrib COMMAND t_kraftattrib)

target_link_libraries(t_kraftattrib ${test_libs})

# ============================================================

add_executable(t_jsonindexfile t_jsonindexfile.cpp)
add_test(NAME t_jsonindexfile COMMAND t_jsonindexfile)

target_link_libraries(t_jsonindexfile ${test_libs})


set(TESTS_PATH ${CMAKE_CURRENT_SOURCE_DIR})
configure_file ("testconfig.h.in" "testconfig.h")

=== debian/changelog ===
kraft (2.0.0-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * Update the patches:
    - Use-the-non-legacy-add_test-CMake-command.patch: drop, fixed upstream
    - Extract-Git-info-at-build-time-only-if-possible.patch: drop, fixed
      upstream
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Tue, 06 Jan 2026 22:32:10 +0100

kraft (2.0.0~rc1-2) experimental; urgency=medium

  * More and more unit tests assume an installed layout for the data, so:
    - install kraft in a local directory, pointing to it via XDG_DATA_DIRS
    - use a static "tmp" subdirectory of the local "test_root" as $TMPDIR,
      so it is already cleaned, and it does not pollute the system $TMPDIR
    - print the leftover temporary files after running the tests, to easily spot
      leaked files
    - drop patch tests-skip-t_defaultprovider.diff, as the test runs fine now
  * Backport the upstream PR https://github.com/dragotin/kraft/pull/272 to use
    the non-legacy add_test() CMake command; patch
    Use-the-non-legacy-add_test-CMake-command.patch
    - drop tests-new-add_test.diff, replaced
  * Backport the upstream PR https://github.com/dragotin/kraft/pull/273 to not
    use 'git' at build time when not available; patch
    Extract-Git-info-at-build-time-only-if-possible.patch
    - drop cmake-fix-without-git.diff, replaced
  * Drop the locales-all build dependency, no more needed by the tests.

 -- Pino Toscano <pino@debian.org>  Tue, 23 Dec 2025 19:40:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: kraft
 Section: kde
-Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -21,13 +20,12 @@
                asciidoctor,
                po4a,
                libqt6sql6-sqlite <!nocheck>,
-               locales-all <!nocheck>,
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://volle-kraft-voraus.de/
-Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kraft.git -b experimental
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kraft/-/tree/experimental
+Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kraft.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kraft
 
 Package: kraft
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,4 +11,10 @@
 	dh $@
 
 override_dh_auto_test:
-	xvfb-run -a env KRAFT_HOME="$(CURDIR)" dh_auto_test --no-parallel
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	cd obj-* && $(MAKE) install DESTDIR=$(CURDIR)/test_root
+	mkdir -p "$(CURDIR)/test_root/tmp"
+	xvfb-run -a dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share TMPDIR="$(CURDIR)/test_root/tmp"
+	# check leftover temporary files
+	cd "$(CURDIR)/test_root/tmp" && find | sort
+endif

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v(\d+\.\d+(?:\.\d+)?(?:[a-zA-Z]+\d+)?)\.tar\.gz/kraft-$1\.tar\.gz/, uversionmangle=s/(beta|rc)/~$1/, dversionmangle=s/\~//" \
  https://github.com/dragotin/kraft/tags .*/v(\d+\.\d+(?:\.\d+)?(?:[a-zA-Z]+\d+)?)\.tar\.gz
